/***********************************************************************
 adriamassanet@gmail.com
 TFC UOC 2013
 NoFeud Social CryptoPrototype
 *************************************************************************/

ctl_sCryptoV2 = new SCryptoV2();
ctl_friendsStatus = [];

function ctl_getToday()
{
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth()+1; //January is 0!
    var yyyy = today.getFullYear();
    if(dd<10){dd='0'+dd} if(mm<10){mm='0'+mm} today = mm+'/'+dd+'/'+yyyy;
    return today;
}
function ctl_getMasterCert()
{
    if (!ctl_storageexist('masterCert')) return null;
    var masterCert= new Certificate();
    masterCert.unserialize(JSON.parse(ctl_storageget('masterCert')));
    masterCert.key = new RSAKey();
    masterCert.key.unserialize(JSON.parse(ctl_storageget('masterPvk')));
    return masterCert;
}

function ctl_getKeyCert()
{
    var keyCert= new Certificate();
    keyCert.unserialize(JSON.parse(ctl_storageget('keyCert')));
    keyCert.key = new RSAKey();
    keyCert.key.unserialize(JSON.parse(ctl_storageget('keyPvk')));
    return keyCert;
}

function ctl_removeAllFriends()
{
    ctl_storageremove("friends");
    ctl_friendsStatus = [];
}

function ctl_getFriendMasterCertificates()
{
    var ret = [];

    if (ctl_storageexist("friends"))
    {
        certificates = JSON.parse(ctl_storageget("friends"));
        for (certNo=0;certNo<certificates.length;++certNo)
        {
            cert = new Certificate();
            cert.unserialize(certificates[certNo]);
            ret.push(cert);
            ctl_sCryptoV2.addFriendMasterPbkCertificate(cert);
        }
    }
    return ret;
}

function ctl_addFriendMasterCertificate(certid, onsuccess, onerror)
{
    $.ajax({
        url: 'http://localhost:3000/api/master/'+certid,
        type: 'GET',
        dataType: 'jsonp',
        success: function(data) {
            if (data==null)
            {
                onerror();
                return;
            }
            certificate = new Certificate();
            certificate.unserialize(data.cert);

            var friendMasterCertificates=[];
            if (ctl_storageexist("friends"))
            {
                friendMasterCertificates = JSON.parse(ctl_storageget("friends"));
            }
            friendMasterCertificates.push(data.cert);
            ctl_storageset('friends',JSON.stringify(friendMasterCertificates));
            ctl_log("Success retrieved master certificate for id "+certid);

            ctl_loadFriendKeyCertificates(
                function() { onsuccess(); },
                function() { onerror(); }
            );
        },
        error: function() { onerror(); }
    });
}

function ctl_setFriendMasterCertificates(certificates)
{
    var serialized = [];

    for (certNo=0;certNo<certificates.length;++certNo)
        serialized.push(certificates[certNo].serialize());

    ctl_storageset('friends',JSON.stringify(serialized));
}

function ctl_getEncryptionKey()
{
    if (ctl_storageexist("encryption"))
    {
        return ctl_storageget("encryption");
    }
    return null;
}

function ctl_setEncryptionKey(key)
{
    ctl_storageset("encryption",key);
}


function ctl_loadFriendKeyCertificatesAjax(urlidtoid,masterCert,friendMasterCertificate,onsuccess)
{
    ctl_log("Retrieving key certificate for master "+
        friendMasterCertificate.subject+" ("+friendMasterCertificate.id()+") ");

    return $.ajax({
        url: 'http://localhost:3000/api/master/'+urlidtoid,
        type: 'GET',
        dataType: 'json',
        success: function(data)
        {
            var pvk=masterCert.key.unenvelope(data.pvkEnveloped);
            var certificate = new Certificate();
            certificate.unserialize(data.certificate);
            certificate.key.unserialize(JSON.parse(pvk));
            ctl_log("+Retrieved key certificate  "+certificate.id()+" for master "+friendMasterCertificate.subject);
            ctl_friendsStatus.push( { cert: friendMasterCertificate,  status : 'OK' });
            ctl_sCryptoV2.addFriendKeyPvkCertificate(certificate);
            onsuccess();
        },
        error: function() {
            ctl_friendsStatus.push( { cert: friendMasterCertificate,  status : 'FAILED' });
            onsuccess();
        }
    });
}

function ctl_loadFriendKeyCertificates(onsuccess, onerror)
{
    ctl_friendsStatus = [];

    var masterCert = ctl_getMasterCert();
    if (masterCert==null) return;

    var requests = [];
    var friendMasterCertificates = ctl_getFriendMasterCertificates();

    for (friendNo =0;friendNo <friendMasterCertificates.length;++friendNo )
    {
        var urlidtoid =friendMasterCertificates[friendNo].id()+'/'+masterCert.id();
        var request = ctl_loadFriendKeyCertificatesAjax(urlidtoid,masterCert,friendMasterCertificates[friendNo],onsuccess);
        requests.push(request);
    }

    $.when.apply(undefined, requests);
}

function ctl_newMasterCertificate( name, onsuccess , onerror )
{
    A = new Certificate();
    A.generateSelfSigned(name,"");

    ctl_storageset("masterCert",JSON.stringify(A.serialize()));
    ctl_storageset("masterPvk", JSON.stringify(A.key.serialize(false)));

    $.ajax({
        url: 'http://localhost:3000/api/master',
        data: { cert:  A.serialize() },
        type: 'POST',
        dataType: 'json',
        success: function() { onsuccess(); },
        error: function() { onerror(); }
    });
}
function ctl_newKeyCertificate( onsuccess , onerror )
{
    var masterCert = ctl_getMasterCert();
    if (masterCert==null) return;

    var keyCertificate = ctl_getMasterCert().issueCertificate(ctl_getToday());

    ctl_log("Creating new key certificate with id "+ctl_getToday());

    ctl_storageset("keyCert",JSON.stringify(keyCertificate.serialize()));
    ctl_storageset("keyPvk",JSON.stringify(keyCertificate.key.serialize(false)));

    ctl_sCryptoV2.setMyKeyCertificate(keyCertificate);

    var friendMasterCertificates = ctl_getFriendMasterCertificates();
    var requests = [];

    var pushCipheredPvks = function (obj, successCallback, errorCallback)
    {
        for (friendNo =0;friendNo <friendMasterCertificates.length;++friendNo )
        {
            ctl_log("Pushing key certificate pvk encrypted to "+
                friendMasterCertificates[friendNo].subject+" ("+friendMasterCertificates[friendNo].id()+") ");

            var pvkSerialized = JSON.stringify(keyCertificate.key.serialize(false));
            var pvkEnveloped = friendMasterCertificates[friendNo].key.envelope(pvkSerialized);
            var urlidtoid =masterCert.id()+'/'+friendMasterCertificates[friendNo].id();
            requests.push($.ajax({
                url: 'http://localhost:3000/api/master/'+urlidtoid,
                data: { pvkEnveloped: pvkEnveloped, certificate : keyCertificate.serialize() },
                type: 'POST',
                dataType: 'json',
                success: function() {  ctl_log("Push succeed"); },
                error: function() { alert("pushCipheredPvks failed"); }
            }));
        }
    };

    $.when.apply(new pushCipheredPvks(), requests).then(function (results) {
        onsuccess();
    });
}
function ctl_newEncryptionKey( onsuccess , onerror )
{
    var masterCert = ctl_getMasterCert();
    if (masterCert==null) { onerror(); return; }
    var sharesVectorInfo = ctl_sCryptoV2.createNewSecretAndGetSharesVectorInfo();
    ctl_log("Created new encryption key "+ctl_sCryptoV2.currentSecret);
    ctl_setEncryptionKey(ctl_sCryptoV2.currentSecret);

    ctl_log("Pushing share to server");
    $.ajax({
        url: 'http://localhost:3000/api/master/'+masterCert.subject+'/share',
        data: sharesVectorInfo,
        type: 'POST',
        dataType: 'json',
        success: function() {  onsuccess();  },
        error: function() { onerror();  }
    });
}
function ctl_encodeMessage(plainText)
{
    return ctl_sCryptoV2.cipherMessage(plainText);
}

function ctl_decodeMessage(originid,cipheredMessage, onsuccess,onerror )
{
    ctl_log("Retrieving share for id "+originid);
    $.ajax({
        url: 'http://localhost:3000/api/master/'+originid+'/share',
        type: 'GET',
        dataType: 'json',
        success: function(data) {
            ctl_log("Share retrieved "+JSON.stringify(data));
            onsuccess(ctl_sCryptoV2.decipherMessage(data,cipheredMessage));
        },
        error: function() { onerror(); }
    });
}
function ctl_doinit( onsuccess, onerror)
{
    ctl_log("Initializing");
    if (ctl_storageexist("keyCert"))
    {
        ctl_log("MasterKey found!");
        ctl_sCryptoV2.setMyKeyCertificate(ctl_getKeyCert());
    } else
    {
        ctl_log("MasterKey NOT found!");
    }
    if (ctl_getEncryptionKey()!=null)
    {
        ctl_log("EncryptionKey found!");
        ctl_sCryptoV2.currentSecret=ctl_getEncryptionKey();
    }
    ctl_loadFriendKeyCertificates(onsuccess,onerror);
}

