function ctl_storageget(key)
{
    return localStorage[key];
}
function ctl_storageset(key,value)
{
    return localStorage[key]=value;
}
function ctl_storageexist(key)
{
    return (localStorage.getItem(key) !== null);
}

function ctl_storageremove(key)
{
    localStorage.removeItem(key);
}

function ctl_log(message)
{
    $('#logs').append(message+"\r\n");
}


function loadFriendList()
{
    $('#friends').empty();
    for (i=0;i<ctl_friendsStatus.length;++i)
    {
        $('#friends').append($('<option>', {
            value: ctl_friendsStatus[i].cert.id(),
            text: ctl_friendsStatus[i].cert.subject + '(' +ctl_friendsStatus[i].cert.id() + ') '+ctl_friendsStatus[i].status
        }));
    }
}

$(function() {

    if ("masterCert" in localStorage)
    {
        $("#masterCert").val(localStorage.masterCert);
        $("#masterPvk").val(localStorage.masterPvk);
    }
    if ("keyCert" in localStorage)
    {
        $("#keyCert").val(localStorage.keyCert);
        $("#keyPvk").val(localStorage.keyPvk);
    }
    if (ctl_getEncryptionKey()!=null)
    {
        $("#keyEncryption").val(ctl_getEncryptionKey());
    }
    ctl_doinit(
        function(){loadFriendList(); },
        function(){ }
    );

    $("#buttonMasterCertGenerate").click(function(){
        var name = window.prompt("What's your id?","");
        ctl_newMasterCertificate(name,
            function() {
                $("#masterCert").val(localStorage.masterCert);
                $("#masterPvk").val(localStorage.masterPvk);
                alert("Success!");
            },
            function() { alert("Failed!"); }
        );
    });

    $("#buttonKeyCertGenerate").click(function(){
        ctl_newKeyCertificate(
            function() {
                $("#keyCert").val(localStorage.keyCert);
                $("#keyPvk").val(localStorage.keyPvk);
                alert("Success!");
            },
            function() { alert("Failed!"); }
        );
    });

    $("#buttonEncryptionKeyGenerate").click(function(){
        ctl_newEncryptionKey(
            function() {
                $("#keyEncryption").text(ctl_sCryptoV2.currentSecret);
                alert("Success!");
            },
            function() { alert("Failed!"); }
        );
    });

    $("#buttonTextEncode").click(function(){
        $("#testEncodePlainText").val(
            ctl_encodeMessage($("#testEncodePlainText").val()));
    });

    $("#buttonTextDecode").click(function(){
        var originid=prompt("origin id?");
        ctl_decodeMessage(
            originid,
            $("#testEncodeCipherText").val(),
            function(plainText) { $("#testEncodePlainText").val(plainText); },
            function() { alert("Failed");}
        );
    });

    $("#buttonServerAdmin").click(function(){
        chrome.tabs.create({'url': "http://localhost:3000" }, function(tab) {
        });
    });
    $("#buttonQueryFriendFromServer").click(function()
    {
        var certificateID  = window.prompt("Id?","");
        ctl_addFriendMasterCertificate(certificateID,
            function() { loadFriendList(); },
            function() { alert("Failed"); }
        );
    });
    $("#buttonRemoveFriends").click(function()
    {
        ctl_removeAllFriends();
        loadFriendList();
    });



});
