/***********************************************************************
 adriamassanet@gmail.com
 TFC UOC 2013
 NoFeud Social CryptoPrototype
 *************************************************************************/

var express = require('express');

var app = express();
app.use(express.bodyParser());

var ObjectID = require("mongodb").ObjectID;
var MongoClient = require('mongodb').MongoClient,
    Server = require('mongodb').Server,
    db;

var mongoClient = new MongoClient(new Server('localhost', 27017));

mongoClient.open(function(err, mongoClient) {
db = mongoClient.db("nofeud");
});

/* ---- master certificates ----- */

master_upload = function(req,res) {
    console.log(JSON.stringify(req.body, null, 4))
    var cert = req.body.cert;
    db.collection('master', function(err, collection) {
        collection.update({id:cert.subject},{id:cert.subject,cert:cert},{upsert:true}, function(err, result) {});
    });
    res.jsonp({success: true});
};


master_get_all = function(req, res) {
    db.collection('master', function(err, collection) {
        collection.find().toArray(function(err, items) {
            res.jsonp(items);
        });
    });
};

master_get_cert = function(req, res) {
    db.collection('master', function(err, collection) {
        collection.findOne({id:req.params.id}, function(err, item) {
            console.log(req.params.id);
            res.jsonp(item);
        });
    });
};

master_delete_all = function(req, res) {
    console.log("MASTER DELETE ALL");
    db.collection('master', function(err, collection) {
        collection.remove(function(err, item) {
        });
    });
    db.collection('share', function(err, collection) {
        collection.remove(function(err, item) {
        });
    });
    res.jsonp({success: true});
};

/* ---- share1 ----- */

share_upload = function(req,res) {
    var id = req.params.id;
    console.log(JSON.stringify(req.body, null, 4))
    var cert = req.body.cert;
    db.collection('share1', function(err, collection) {
        collection.update({id:id},{id:id,data:req.body},{ upsert: true }, function(err, result) {});
    });
    res.jsonp({success: true});
};

share_download = function(req,res) {
    var id = req.params.id;

    db.collection('share1', function(err, collection) {
        collection.findOne({id:id}, function(err, item) {
            if (item==null)
            {
                res.status(404).send('Not found');
                console.log("JOJO");
            }
            else
            {
                res.jsonp(item.data);
                console.log("JOJA");
            }
        });
    });
};


/* ---- keycerts ----- */


keycert_upload = function(req,res) {
    var id = req.params.idfrom +"."+req.params.idto;

    console.log(JSON.stringify(req.body, null, 4))
    var cert = req.body.cert;
    db.collection('share', function(err, collection) {
        collection.update({id:id},{id:id,data:req.body},{upsert:true}, function(err, result) {});
    });
    res.jsonp({success: true});
};

keycert_download = function(req,res) {
    var id = req.params.idfrom +"."+req.params.idto;

    db.collection('share', function(err, collection) {
        collection.findOne({id:id}, function(err, item) {
            if (item==null)
                res.status(404).send('Not found');
            else
                res.jsonp(item.data);
        });
    });
};

var allowCrossDomain = function(req, res, next) {
    res.header('Access-Control-Allow-Origin', '*');
    res.header('Access-Control-Allow-Methods', 'GET,PUT,POST,DELETE,OPTIONS');
    res.header('Access-Control-Allow-Headers', 'Content-Type, Authorization, Content-Length, X-Requested-With');

    // intercept OPTIONS method
    if ('OPTIONS' == req.method) {
        res.send(200);
    }
    else {
        next();
    }
};
app.use(allowCrossDomain);

app.get("/api/master",master_get_all)
app.delete('/api/master',master_delete_all);

// public certificates
app.post("/api/master",master_upload);
app.get("/api/master/:id",master_get_cert)

app.post("/api/master/:id/share",share_upload);
app.get("/api/master/:id/share",share_download)

// certificate+pvks to anothers
app.post("/api/master/:idfrom/:idto",keycert_upload);
app.get("/api/master/:idfrom/:idto", keycert_download);


app.use("/", express.static(__dirname + '/static'), {maxAge: 1});
app.listen(3000);
console.log('Listening on port 3000...');
