var leftbeat = false;
var rightbeat = false;
var startTime = -1;
var lastKeyDown=0;
var NOPREVIOUS=99999999;
var lastKeyDownTime=NOPREVIOUS;
var timeoutId=0;
var canvas;
var beatEvents=Array();
var beatSong=Array();
var beatSongCurrentPosIndex = 0;
var score=0;
var recording = false;
var currentSongId=null;
var adminKey ='';

function drawCanvas()
{
	var CANVAS_WIDTH =400;
	var CANVAS_HEIGHT=400;
	var TOP_SIZE     = 20;
	var BOTTOM_SIZE  = 300;
	
	var MS_PER_PIXEL = 5;
	var DOT_SIZE_X   = 150;
	var DOT_SIZE_Y   = 20;
	var TIME_OFFSET  = 1000;
	
	var size=8;
	var now = new Date().getTime()-startTime;

	canvas.fillStyle="#FFFFFF";
	canvas.fillRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);	
	
	for (index = 0; index < beatSong.length; ++index)
	{
		canvas.fillStyle="#AAAAAA";
		if (index==beatSongCurrentPosIndex) canvas.fillStyle="#EEEEEE";
		var beatEvent = beatSong[index];
		var canvasY = (now-beatEvent.t+TIME_OFFSET)/MS_PER_PIXEL;
		if (canvasY > 0 && canvasY < CANVAS_HEIGHT)
		{
			if (beatEvent.e=="L" || beatEvent.e.length>1 )
			{
				canvas.fillRect(50,canvasY,DOT_SIZE_X,DOT_SIZE_Y);
			}
			if (beatEvent.e=="R" || beatEvent.e.length>1 )
			{	
				canvas.fillRect(50+DOT_SIZE_X,canvasY,DOT_SIZE_X,DOT_SIZE_Y);
			}
		};
	}
	for (index = 0; index < beatEvents.length; ++index)
	{
		var beatEvent = beatEvents[index];
		var canvasY = (now-beatEvent.t+TIME_OFFSET)/MS_PER_PIXEL;
		if (canvasY > 0 && canvasY < CANVAS_HEIGHT )
		{
			if (beatEvent.e=="L" || beatEvent.e.length>1 )
			{
				canvas.fillStyle="#FF0000";
				canvas.fillRect(50,canvasY,DOT_SIZE_X,DOT_SIZE_Y);
			}
			if (beatEvent.e=="R" || beatEvent.e.length>1 )
			{	
				canvas.fillStyle="#00FF00";
				canvas.fillRect(50+DOT_SIZE_X,canvasY,DOT_SIZE_X,DOT_SIZE_Y);
			}
		};
	}
	canvas.fillStyle="#FF0000";
	canvas.fillRect(0,TIME_OFFSET/MS_PER_PIXEL,CANVAS_WIDTH,2);
	var ii=beatSongCurrentPosIndex;
	if (beatSongCurrentPosIndex>=0)
		ii=now-beatSong[beatSongCurrentPosIndex].t;
	$('#score').text(score+" punts");
}

function keyPressed(keyDown,keyCode)
{
	if (startTime==-1) return;
	
	var maxError=50;
	var now = new Date().getTime()-startTime;
	while (	beatSongCurrentPosIndex>=0
		&& (beatSong[beatSongCurrentPosIndex].t+maxError<now ))	
	{
		if (beatSongCurrentPosIndex<beatSong.length-1)
			beatSongCurrentPosIndex++;
		else
			beatSongCurrentPosIndex=-1;
	}
	if (keyCode==83 || keyCode==75)
	{
		if (keyCode==83) leftbeat = keyDown;	
		if (keyCode==75) rightbeat = keyDown;
		if (keyDown)
		{
			// queue
			var text = "";
			if (leftbeat) text+="L";
			if (rightbeat) text+="R";	
			lastKeyDownTime = now;
			lastKeyDown=text;

			clearTimeout(timeoutId);
			timeoutId=setTimeout(function(){keyPressed(0,0);},50);
		}
		return;
	}
	if (lastKeyDownTime!=NOPREVIOUS && (now - lastKeyDownTime) > 40)
	{	
		beatEvents.push({t:lastKeyDownTime,e:lastKeyDown});
		lastKeyDownTime=NOPREVIOUS;
		clearTimeout(timeoutId);
		if (beatSongCurrentPosIndex>=0)
		{
			var delta = now-beatSong[beatSongCurrentPosIndex].t;
			if (delta<0) delta=-delta;

			if (delta < maxError) 
				score += (maxError-delta);
			else score -= 20;
		} else score -= 20;
	}
	if (score < 0 ) score=0;
	timeoutId=setTimeout(function(){keyPressed(0,0);},50);
	drawCanvas();	
}

function reloadSongs()
{
	$.getJSON( "/api/songs", function( data ) {
		var songTableItems = [];
		var songSelectItems = [];

		for (var i = 0; i < data.length; i++) {
			songTableItems.push('<tr><td>'+data[i].songname+'</td></td>');
			songTableItems.push('<td><button type="button" class="btn btn-primary btn-sm btn-danger" onclick=\'javascript:deleteSong("'+data[i].id+'")\'>Esborrar</button>&nbsp;');

			if (("score" in data[i]) || adminKey!='')
				songSelectItems.push('<option value=\''+data[i].id+'|'+JSON.stringify(data[i].score)+'\'>'+data[i].songname+'</option>');

			songTableItems.push('</td></tr>');
		}
		$("#song-table").html(songTableItems.join(''));
		$("#song-select").html(songSelectItems.join(''));
		$("#song-select").change();

	});	
}

function deleteSong(id)
{
	$.ajax({
		url: '/api/songs/'+id,
		type: 'DELETE',
		username: adminKey,
  		password: adminKey,
		success: function(result) {
			reloadSongs();
		}
	});	
}


function emptySong(id)
{
	alert("empty "+id);
}

function setAdminMode(pass)
{
	$.getJSON( "/api/auth/"+pass, function( data )
	{
		if (data.success==false)
		{
			bootbox.alert("Aquesta no es" , {}, function() {} );
		} else
		{
			adminKey=pass;
			$("#record").show();
			reloadSongs();
			$('#menu-gestio').trigger('click');
		}
	});
}

$(function()
{
	if (navigator.userAgent.indexOf("Chrome")==-1)
	{
		var msg = "Aquesta aplicaciò nomes funciona amb Google Chrome!";
		bootbox.alert("Aquesta aplicaciò nomes funciona amb Google Chrome!", function() 
		{
			document.location.href = "http://www.google.com/intl/ca/chrome/";
		});
	}
	reloadSongs();
});
